#!/usr/bin/python

#python script by Tak Lee for 2016 BIML network analysis 
#Usage: To predict function of genes by direct neighborhood
#$python GBA_predict_func.py [input genes] [input network] [input annotation terms] > [output file] 

import os,sys
from operator import itemgetter

goterms = {}
neighbors = {}

#read in guide genelists
input_genes = [inputs for inputs in ((l.strip()) for l in open(sys.argv[1],'r'))]
#read in the network and store linked neighbors
for network in open(sys.argv[2],'r'):
	(g1,g2,s) = (network.strip()).split('\t')
	s = float(s)
	if g1 in input_genes: 
		if g1 not in neighbors:
			neighbors[g1] = [(g2,s)]
		else:
			neighbors[g1].append((g2,s))
	if g2 in input_genes: 
		if g2 not in neighbors:
			neighbors[g2] = [(g1,s)]
		else:
			neighbors[g2].append((g1,s)) 
#read in goterms, save the goterms one by one through parsing the whole term with ;
for gterm in open(sys.argv[3],'r'):
	(g,term) = (gterm.strip()).split('\t')
	goterms[g] = term.split(';')
score = {} #a dictionary used to sum the scores of each terms.
all_neighbors = {} #a dictionary used for printing output
#map the neighboring genes to their goterms. Assign the scores to goterms and sum them up.
for genes in input_genes:
	if genes in neighbors:
		for ngene,nscore in neighbors[genes]:
			if ngene in goterms:
				for nterms in goterms[ngene]:
					#This if statement is for printing out the results
					if nterms not in all_neighbors:
						all_neighbors[nterms] = [ngene,float(nscore)]
					else:
						all_neighbors[nterms].append(ngene)
						all_neighbors[nterms].append(nscore)
					#This if statement is for summing the scores for "each term"
					if nterms not in score:
						score[nterms] = 0
						score[nterms] += float(nscore)
					else:
						score[nterms] += float(nscore)
	#print out results
	print ("input gene: "+genes)
	k = 1 #to show rank of the result
	for pred_term,score_sum in sorted(score.items(),key=itemgetter(1),reverse=True):
		if(score_sum >= 1.5 and k < 51):
			print "%s\t%s\t%s\t" %(str(k),str(score_sum),pred_term) + " ".join([str(x) for x in all_neighbors[pred_term]]) 
		k += 1
	all_neighbors={}
	score = {}
		
		
